declare("ma", {})
dofile("items.lua")

ma.version = "   v1.2"
--[[ README/update log
	use /ma to bring up the main menu. choose your part from the dropdown menu. there are 5 ways to view prgress towards a part in the other drop down menu.
	double click an item name in the menu to bring up a info panel on it. roid locs are for target system and current system only
	all settings/data should be saved between logins
	click the farm button to bring up a progress bar for farming an item
	
	v1.0 7/24/23
	v1.1 added farming section beta state
	v1.2 fixed item set from dropdown in farming and goal completion
]]

ma.view = gkini.ReadString("MA", "view", "Tree")
ma.part = gkini.ReadInt("MA", "part", 1781660161)
if ma.manufacturables[ma.part] then
else
	ma.part = 1781660161
end
ma.quantity = gkini.ReadInt("MA", "quantity", 1)

ma.back = {}
for k, v in pairs(ma.itemIds) do
	ma.back[v] = k
end

function ma.ini(key, value)
	if value then
		if type(value) == "string" then
			value = value
		elseif type(value) == "number" then
			value = value
		else
			value = 1
		end
	else
		value = 0
	end

	if (key == 1) then --view
		gkini.WriteString("MA", "view", tostring(value))
	elseif (key == 2) then --part
		if ma.manufacturables[tonumber(value)] then
			gkini.WriteInt("MA", "part", tonumber(value))
		end
	elseif (key == 3) then --quantity
		gkini.WriteInt("MA", "quantity", tonumber(value))
	elseif (key == 4) then --farm item
		gkini.WriteString("MA", "farmitem", tostring(value))
	elseif (key == 5) then --farmgoal
		gkini.WriteInt("MA", "farmgoal", tonumber(value))
	elseif (key == 6) then --farmprog
		gkini.WriteInt("MA", "farmprog", tonumber(value))
	end
end

function ma.return_list(part, quantity)
	local returnStr = ""
	if ma.manufacturables[part] then
		returnStr = returnStr.."\n\n"..ma.itemIds[part].." "..tostring(quantity)
		for k, v in pairs(ma.manufacturables[part].items) do
			local new = ma.return_list(k, v*quantity)
			returnStr = returnStr..new
		end
		returnStr = returnStr.."\n"
		return returnStr
	elseif ma.itemIds[part] then
		return "\n"..ma.itemIds[part].." "..tostring(quantity)
	end
end

function ma.create_full_list(part, quantity)
	local masterStr = ""
	if ma.manufacturables[part] then
		for k, v in pairs(ma.manufacturables[part].items) do
			masterStr = masterStr..ma.return_list(k, v*quantity)
		end
		print(masterStr)
	end
end

--/lua ma.get_table_reqs(1781660161, 1)

function ma.get_complete_reqs(part, quantity)
	local master = {}
	local master2 = {}
	
	local function table_add(part, quantity, mast)
		--part = ma.itemIds[part]
		if mast == 1 then
			if master[part] then
				master[part] = master[part] + quantity
			else
				master[part] = quantity
			end
		else
			if master2[part] then
				master2[part] = master2[part] + quantity
			else
				master2[part] = quantity
			end
		end
	end
	
	local function recursive_part_search(part, quantity)
		if ma.manufacturables[part] then
			table_add(part, quantity, 2)
			for k, v in pairs(ma.manufacturables[part].items) do
				recursive_part_search(k, v*quantity)
			end
		else
			table_add(part, quantity, 1)
		end
	end
	
	recursive_part_search(part, quantity)
	
	return master2, master
end

local function get_pxs_clr(prog, targ)
	local pixels, color
	local pct = prog / targ
	pixels = pct * 500

	if pixels > 500 then
		pixels = 500
		color = "0 0 255"
	elseif pixels > 400 then
		color = "0 255 0"
	elseif pixels > 300 then
		color = "255 255 0"
	elseif pixels > 200 then
		color = "255 165 0"
	elseif pixels > 100 then
		color = "255 0 0"
	elseif pixels > 0 then
		color = "0 0 0"
	else
		pixels = 1
		color = "0 0 0"
	end
	
	return pixels, color
end

local function create_subdlg(ctrl, x, y)
	local dlg = iup.dialog{ctrl, border="NO", menubox="NO", resize="NO", expand = "YES", size = x.."x", bgcolor = "0 0 0 0 *",} --x500
	iup.Map(dlg)
	if (y - dlg.h) > 0 then
		local x1 = iup.GetNextChild(ctrl, nil)
		local v1 = iup.GetNextChild(x1, nil)
		iup.Append(v1, iup.fill{size = y-dlg.h,})
	end
	dlg.visible = "YES"
	return dlg
end

local function create_scrollbox(content, x, y)
	local scrollbox = iup.stationsublist{{}, control = "YES", expand = "YES", border = "NO", size = x.."x"..y}
	iup.Append(scrollbox, create_subdlg(content, x-35, y))
	scrollbox[1] = 1
	return scrollbox
end

local function create_frame_vbox(ctrl)
	local frame = iup.pdarootframe{iup.vbox(ctrl), bgcolor = "111 111 111 200 &", border = "0 0 0 0", expand = "YES"}
	return iup.vbox{frame,}
end

local function get_station(part)
	local station
	part = tonumber(part)
	--print(part)
	if ma.manufacturables[part] then
		if ma.manufacturables[part].stations[1] ~= "Dunno" then
			station = ma.manufacturables[part].stations[1]
		elseif GetCurrentStationID() then
			station = ShortLocationStr(SplitStationID(GetCurrentStationID()))
		elseif GetAvailableMissions() then
			local smallestDist = math.huge
			local smallestDistStationId

			for _, data in ipairs(GetAvailableMissions()) do
				if data.dist < smallestDist then
					smallestDist = data.dist
					smallestDistStationId = data.stationid
				end
			end

			station = ShortLocationStr(SplitStationID(smallestDistStationId))
		else
			station = ShortLocationStr(GetHomeStation())
		end
	else
		station = ShortLocationStr(GetHomeStation())
	end
	
	return station
end

local function name(part)
	return ma.itemIds[tonumber(part)] or "None"
end

local function cu(part)
	local prototype = InvManager.GetInventoryItemPrototype(part)
	local cargo = prototype:GetVolume() or 0
	return cargo
end

local function id(part)
	return ma.back[part]
end

local function image(part)
	local prototype = InvManager.GetInventoryItemPrototype(part)
	local image = prototype:GetIcon()
	return image
end

local function images(part)
	local images = {}
	
	local function recurse(part)
		if ma.manufacturables[part] then
			if not images[part] then
				images[part] = image(part)
			end

			for k, v in pairs(ma.manufacturables[part].items) do
				recurse(k)
			end
		else
			if not images[part] then
				images[part] = image(part)
			end
		end
	end
	
	recurse(part)
	
	return images
end

local function index(list, target)
	for i, item in ipairs(list) do
		if item == target then
			return i
		end
	end
end

function ma.get_table_reqs(part, quantity)

    local function recursive_part_search(part, quantity, table2)
        if ma.manufacturables[part] then
            if not table2[name(part).." X "..tostring(quantity)] then
                table2[name(part).." X "..tostring(quantity)] = {}
            end

            for k, v in pairs(ma.manufacturables[part].items) do
                recursive_part_search(k, v * quantity, table2[name(part).." X "..tostring(quantity)])
            end
        else
			table2[name(part).." X "..tostring(quantity)] = true
            ----add part the manufacturable table that it is an item of
        end
		return table2
    end

    local resultTable = {}
    --recursive_part_search(part, quantity, resultTable)

    --print(spickle2(resultTable))
	--return resultTable
	return recursive_part_search(part, quantity, resultTable), part
end

function ma.iup()
	local tb, part = ma.get_table_reqs(1781660161, 1)
	local images = images(part)
	--print(spickle2(tb))
	local tree = iup.tree{}
	tree.name = "MA"
	iup.TreeSetUserId(tree, 0, "MA")
	
	local function createTreeFromTable(tableData, node)
		for key, value in pairs(tableData) do
			if type(value) == "table" then
				tree:addbranch(node, key)
				createTreeFromTable(value, node + 1)
			else
				tree:addleaf(node, key)
			end
		end
	end
	
	createTreeFromTable(tb, 0)

	local dlg = iup.dialog{tree, size = "1000x1000",}

	dlg:show(iup.CENTER, iup.CENTER)
end

function ma.part_info(part, station_roid) -- /lua ma.part_info(1020269572)
	local dlg
	local switch = "TA"
	
	local image = iup.label{size = "100x100", image = image(part), title = "",}
	local cuBar = iup.label{title = "CU: "..tostring(cu(part)),}
	local title = iup.label{title = name(part), font = "30",}
	local invTitle = iup.label{title = "Inventory", size = "205", alignment = "ACENTER",}
	local taTitle = iup.label{title = "TA Data", size = "205", alignment = "ACENTER",}
	local closebtn = iup.stationbutton{title = "Close"}
	
	local compare = name(part)
	
	local whereBuy = {}
	
	if ma.isOre[part] then
		switch = "ROIDDB"
		taTitle.title = "RoidDB Data"
		local currentid = GetCurrentSystemid()
		local targetid = SystemNames[string.lower(string.match(station_roid, "%a+"))] or currentid
		
		local oresC = unspickle(LoadSystemNotes(7643320 + currentid))

		for k, v in pairs(oresC) do
			local ct = 0
			for i, v in ipairs(v) do
				for k, v in pairs(v["ore"]) do
					if k == ma.isOre[part] then
						ct = ct + 1
					end
				end
			end
			if ct > 0 then
				whereBuy[ShortLocationStr(k)] = ct
			end
		end
		if currentid ~= targetid then
			local oresT = unspickle(LoadSystemNotes(7643320 + targetid))

			for k, v in pairs(oresT) do
				local ct = 0
				for i, v in ipairs(v) do
					for k, v in pairs(v["ore"]) do
						if k == ma.isOre[part] then
							ct = ct + 1
						end
					end
				end
				if ct > 0 then
					whereBuy[ShortLocationStr(k)] = ct
				end
			end
		end
	else
		local ta = unspickle(LoadSystemNotes(20100201))
		
		if next(ta) then
			for k, v in pairs(ta.goods) do
				if v.name == compare then
					for a, b in pairs(v) do
						if type(b) == "table" then
							if b["s"] then
								whereBuy[ShortLocationStr(ta.stations[a].sectorid)] = b["s"]
							end
						end
					end
				end
			end
		end
	end
	
	--print(spickle2(whereBuy))
	
	local inventory = {}
	
	for _, item in PlayerInventoryPairs() do
		local name = tostring(GetInventoryItemName(item))
		if name == compare then
			local stationI = ShortLocationStr(SplitStationID(GetInventoryItemLocation(item)))
			local amount = tonumber(GetInventoryItemQuantity(item))
			inventory[stationI] = amount
		end
	end
	
	local function compare(a, b)
		return a["a"] < b["a"]
	end
	
	local inv1 = {}
	for k, v in pairs(inventory) do
		local mini = {["a"] = k, ["b"] = v}
		table.insert(inv1, mini)
	end
	local whb1 = {}
	for k, v in pairs(whereBuy) do
		local mini = {["a"] = k, ["b"] = v}
		table.insert(whb1, mini)
	end
	table.sort(inv1, compare)
	table.sort(whb1, compare)
	
	local invs = {}
	local tas = {}
	local function create_hboxes(stat, quan, tb, color)
		local x1 = iup.label{title = stat, size = "200", alignment = "ACENTER",}
		local x2 = iup.label{title = tostring(quan), size = "100", alignment = "ACENTER",}
		local hbox = iup.hbox{x1, x2, gap = "5",}
		if color then
			x1.fgcolor = "0 0 0"
			x2.fgcolor = "0 0 0"
		end
		if tb == 1 then
			table.insert(invs, hbox)
		elseif tb == 2 then
			table.insert(tas, hbox)
		end
	end
	
	create_hboxes("Station", "Amount", 1, true)
	for i, v in ipairs(inv1) do
		create_hboxes(v["a"], v["b"], 1)
	end
	
	local invSection = iup.vbox{
		invTitle,
		create_scrollbox(create_frame_vbox(invs), 340, 200),
		gap = "5",
	}
	
	if switch == "TA" then
		create_hboxes("Station", "Cost", 2, true)
	else
		create_hboxes("Sector", "Roids", 2, true)
	end
	
	for i, v in ipairs(whb1) do
		create_hboxes(v["a"], v["b"], 2)
	end
	
	local taSection = iup.vbox{
		taTitle,
		create_scrollbox(create_frame_vbox(tas), 340, 200),
		gap = "5",
	}
	
	local data_section = iup.hbox{
		invSection,
		taSection,
		gap = "15",
	}
	
	local info_section = iup.hbox{
		iup.vbox{
			image,
		},
		iup.vbox{
			iup.hbox{
				size = "x5",
			},
			title,
			cuBar,
			gap = "5",
		},
		gap = "10",
	}
	
	local main = iup.pdarootframe{
		iup.vbox{info_section, data_section, closebtn, gap = "10",},	
		border = "YES",
		expand = "NO",
		bgcolor = "100 100 100 255 ^",
		fgcolor = "100 100 100 255 &",
	}
			
	dlg = iup.dialog{
		iup.vbox{
			iup.fill{},
			iup.hbox{
				iup.fill{},
				main,
				iup.fill{},
			},
			iup.fill{},
		},
		expand = "NO",
		topmost = "YES",
		fullscreen = "YES",
		defaultesc = closebtn,
		bgcolor = "0 0 0 64 *",
	}
	
	function closebtn:action()
		dlg:hide()
		dlg = nil
		collectgarbage()
	end

	dlg:show(iup.CENTER, iup.CENTER)
end

ma.Farm = {}
ma.Farm.targetItem = gkini.ReadString("MA", "farmitem", "Synthetic Silksteel")
ma.Farm.targetGoal = gkini.ReadInt("MA", "farmgoal", 1)
ma.Farm.targetProg = gkini.ReadInt("MA", "farmprog", 0)
ma.Farm.inventory = {}


function ma.Farm.update(event, data)
	if event == "INVENTORY_ADD" then
		local quan = tonumber(GetInventoryItemQuantity(id))
		ma.Farm.inventory[data] = quan
	elseif event == "INVENTORY_UPDATE" then
		if ma.Farm.inventory[data] then
			local diff = tonumber(GetInventoryItemQuantity(data)) - ma.Farm.inventory[data]
			ma.Farm.targetProg = ma.Farm.targetProg + diff
			if (ma.Farm.targetProg >= ma.Farm.targetGoal) then
				print("\127FFD700Farming goal of " .. ma.Farm.targetGoal .. " " .. ma.Farm.targetItem .. "completed!")
			end
			ma.Farm.inventory[data] = tonumber(GetInventoryItemQuantity(data))
		end
	elseif event == "PLAYER_ENTERED_GAME" then
		for i, v in PlayerInventoryPairs() do
			local id = v
			local name = GetInventoryItemName(id)
			if name == ma.Farm.targetItem then
				local quan = tonumber(GetInventoryItemQuantity(id))
				ma.Farm.targetProg = ma.Farm.targetProg + quan
				ma.Farm.inventory[id] = quan
			end
		end
	end
end

RegisterEvent(ma.Farm.update, "INVENTORY_ADD")
RegisterEvent(ma.Farm.update, "INVENTORY_UPDATE")
RegisterEvent(ma.Farm.update, "PLAYER_ENTERED_GAME")

function ma.Farm.create_bar()
	local px, cl = get_pxs_clr(ma.Farm.targetProg, ma.Farm.targetGoal)
	local barBack = iup.label{title = "", size = "500x", bgcolor = "100 100 100"}
	local barProg = iup.label{title = "", size = px.."x", bgcolor = cl}
	local bar = iup.zbox{barBack, barProg, ALL = "YES", alignment = "WEST"}
	
	local title = iup.label{title = ma.Farm.targetItem, size = "760x", alignment = "ACENTER"}
	local left = iup.label{title = tostring(ma.Farm.targetProg), size = "100x", alignment = "ACENTER"}
	local right = iup.label{title = tostring(ma.Farm.targetGoal), size = "100x", alignment = "ACENTER"}
	local main2 = iup.hbox{
		iup.vbox{
			iup.hbox{
				title,
			},
			iup.hbox{
				left,
				bar,
				right,
				gap = "10",
			},
			gap = "10",
		},
	}
	
	return main2
end

function ma.drop_farming()
	local dlg
	--local targetItem = "Synthetic Silksteel"
	--local targetGoal = 2000
	--local targetProg = 1000
	
	local main2 = ma.Farm.create_bar()
	
	local closebtn = iup.stationbutton{title = "Close"}
	local changebtn = iup.stationbutton{title = "Change Farm"}
	local btns = iup.hbox{closebtn, changebtn, gap = "5"}
	
	local main = iup.pdarootframe{
		iup.vbox{iup.hbox{main2}, btns, gap = "10"},	
		expand = "NO",
		bgcolor = "100 100 100 255 ^",
	}
			
	dlg = iup.dialog{
		iup.vbox{
			iup.fill{},
			iup.hbox{
				iup.fill{},
				main,
				iup.fill{},
			},
			iup.fill{},
		},
		expand = "NO",
		topmost = "YES",
		fullscreen = "YES",
		defaultesc = closebtn,
		bgcolor = "0 0 0 0 *",
	}
	
	function closebtn:action()
		dlg:hide()
		dlg = nil
		collectgarbage()
	end
	
	function changebtn:action()
		local item_SET = ma.Farm.targetItem
		
		local items = {}
		local dropdown_item = iup.stationsublist{
			dropdown = "YES",
			expand = "HORIZONTAL",
			size = "300x",
			expand = "NO",
			action = function(self, text, index, state)
				if state == 1 then
					item_SET = items[index]
				end
			end
		}
		
		function dropdown_item:populate()
			local idx = 1
			for k, v in pairs(ma.itemIds) do
				dropdown_item[idx] = name(k)
				table.insert(items, name(k))
				idx = idx + 1
			end
		end
		dropdown_item:populate()
		dropdown_item.value = index(items, item_SET)
		local itemTitle = iup.label{title = "Item", size = "300", alignment = "ACENTER"}
		local itemBit = iup.hbox{itemTitle, dropdown_item, gap = "5"}
		
		local textGoal = iup.text{
			size = "300",
			value = ma.Farm.targetGoal,
			action = function(self, key, new_text)
				if new_text ~= "" then
					self.value = new_text or "1"
				end
			end,
		}
		local goalTitle = iup.label{title = "Goal", size = "300", alignment = "ACENTER"}
		local goalBit = iup.hbox{goalTitle, textGoal, gap = "5"}
		
		local textProg = iup.text{
			size = "300",
			value = ma.Farm.targetProg,
			action = function(self, key, new_text)
				if new_text ~= "" then
					self.value = new_text or "0"
				end
			end,
		}
		local progTitle = iup.label{title = "Progress", size = "300", alignment = "ACENTER"}
		local progBit = iup.hbox{progTitle, textProg, gap = "5"}

		local set = iup.stationbutton{title = "Set"}
		local mainNew = iup.vbox{
			itemBit,
			progBit,
			goalBit,
			set,
			gap = "5"
		}

		local dlg2 = iup.dialog{
			iup.vbox{
				iup.fill{},
				iup.hbox{
					iup.fill{},
					iup.pdarootframe{
						mainNew,	
						expand = "NO",
						bgcolor = "100 100 100 255 ^",
					},
					iup.fill{},
				},
				iup.fill{},
			},
			topmost = "YES",
			fullscreen = "YES",
			--defaultesc = closebtn,
			bgcolor = "0 0 0 64 *",
		}

		function set:action()
			ma.Farm.targetItem = item_SET
			ma.ini(4, ma.Farm.targetItem)
			local goal = tonumber(textGoal.value) or 1
			if goal > 0 then
				ma.Farm.targetGoal = goal
			else
				ma.Farm.targetGoal = 1
			end
			ma.ini(5, ma.Farm.targetGoal)
			local progress = tonumber(textProg.value) or 0
			if progress > 0 then
				if progress < ma.Farm.targetGoal then
					ma.Farm.targetProg = progress
				else
					ma.Farm.targetProg = ma.Farm.targetGoal - 1
				end
			else
				ma.Farm.targetProg = 0
			end
			ma.ini(6, ma.Farm.targetProg)
			
			dlg2:hide()
			dlg2 = nil
			collectgarbage()
			
			local parent = iup.GetParent(main2)
			iup.Detach(main2)
			iup.Destroy(main2)
			main2 = ma.Farm.create_bar()
			iup.Append(parent, main2)
			iup.Map(dlg)
			iup.Refresh(dlg)
		end

		iup.Map(dlg2)
		dlg2:show(iup.CENTER, iup.CENTER)
	end

	dlg:show(iup.CENTER, iup.CENTER)
end

function ma.iup_create(part, quantity) --/lua ma.iup_create(1781660161, 1)
	local view_section
	local dlg
	local tree_main = nil
	local part_SET = ma.part
	local quantity_SET = ma.quantity
	local view_SET = ma.view
	local station_SET = get_station(part)
	
	local view_types = {"Tree", "List (Full)", "List (Local)", "List (Global)", "Station"}
	local manufacturables = {}
	local dropdown_manu = iup.stationsublist {
        dropdown = "YES",
        expand = "HORIZONTAL",
		size = "525x",
		expand = "NO",
        action = function(self, text, index, state)
            if state == 1 then
				part_SET = manufacturables[index]
				ma.part = manufacturables[index]
				ma.ini(2, ma.part)
            end
        end
    }
	
    function dropdown_manu:populate()
		local idx = 1
        for k, v in pairs(ma.manufacturables) do
			dropdown_manu[idx] = name(k)
			table.insert(manufacturables, k)
			idx = idx + 1
		end
    end
	dropdown_manu:populate()
	dropdown_manu.value = index(manufacturables, part_SET)
	
	local dropdown_view = iup.stationsublist {
        dropdown = "YES",
        expand = "HORIZONTAL",
		size = "240x",
		expand = "NO",
        action = function(self, text, index, state)
            if state == 1 then
				view_SET = view_types[index]
				ma.view = view_types[index]
				ma.ini(1, ma.view)
            end
        end
    }
	
    function dropdown_view:populate()
        for i, v in ipairs(view_types) do
			dropdown_view[i] = v
		end
    end
	dropdown_view:populate()
	dropdown_view.value = index(view_types, view_SET)

	local quantity_text = iup.text{
		size = "100",
		value = quantity_SET,
		alignment = "ARIGHT",
		action = function(self, key, new_text)
			if new_text ~= "" then
				if tonumber(new_text) then
					quantity_SET = tonumber(new_text)
					ma.quantity = quantity_SET
					ma.ini(3, ma.quantity)
				else
					value = "1"
				end
			end
		end,
	}
	
	local function create_tree()
		local tree = iup.tree{size = "1000x500"}
		tree.name = name(part_SET)
		iup.TreeSetUserId(tree, 0, name(part_SET))
		local node = 0
		
		local function recursive_part_search(part, quantity, depth)
			local str = name(part).." X "..tostring(quantity)
			local image = image(part)
			node = node + 1
			if ma.manufacturables[part] then
				tree:addbranch(node, str)
				tree:setimage(node, image)
				tree:setdepth(node, depth)
				for k, v in pairs(ma.manufacturables[part].items) do
					recursive_part_search(k, v * quantity, depth + 1)
				end
			else
				tree:addleaf(node, str)
				tree:setimage(node, image)
				tree:setdepth(node, depth)
			end
		end
		
		recursive_part_search(part_SET, quantity_SET, 1)
		
		return tree
	end
	
	local function create_full()
		local full-- = iup.hbox{size = "1000x500"}
		local inventory = {}
		for _, item in PlayerInventoryPairs() do
			local name = tostring(GetInventoryItemName(item))
			if ma.back[name] then
				--print(name)
				local id = id(name)
				local amount = tonumber(GetInventoryItemQuantity(item))
				if inventory[id] then
					inventory[id] = inventory[id] + amount
				else
					inventory[id] = amount
				end
			end
		end
		local manu_full, rest_full = ma.get_complete_reqs(part_SET, quantity_SET)
		manu_full[part_SET] = nil
		local manu_have = {}
		for k, v in pairs(manu_full) do
			manu_have[k] = 0
		end
		local rest_have = {}
		for k, v in pairs(rest_full) do
			rest_have[k] = 0
		end
		local manu_used = {}
		for k, v in pairs(manu_full) do
			manu_used[k] = 0
		end
		local rest_used = {}
		for k, v in pairs(rest_full) do
			rest_used[k] = 0
		end
		
		for k, v in pairs(inventory) do
			if manu_full[k] then
				--print("ya")
				manu_have[k] = manu_have[k] + v
			elseif rest_full[k] then
				--print("ya2")
				rest_have[k] = rest_have[k] + v
			else
				--print(k)
			end
		end
		
		--print(spickle2(manu_full))
		
		local function recursive_part_search(part, quantity, orig)
			if ma.manufacturables[part] then
				if part ~= orig then
					manu_used[part] = manu_used[part] + quantity
				end
				for k, v in pairs(ma.manufacturables[part].items) do
					recursive_part_search(k, v * quantity)
				end
			else
				rest_used[part] = rest_used[part] + quantity
			end
		end
			
		for k, v in pairs(manu_have) do
			if v > 0 then
				if v <= manu_full[k] then
					recursive_part_search(k, v, k)
				else
					recursive_part_search(k, manu_full[k], k)
				end
			end
		end
		
		--print(spickle(inventory))
		--print(spickle(rest_have))
		local nameSize = "524x25"
		local labelSize = "142"
		local titleColor = "0 0 0"
		local fontGreen = "0 255 0"
		local fontRed = "255 0 0"
		local a = "ACENTER"
		
		local hboxes = {gap = "5"}
		local hbox_title = iup.hbox{
			iup.label{title = "Name", size = nameSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Have", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Used", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Required", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			gap = "5",}
		--table.insert(hboxes, hbox_title)
		
		local function create_hbox_line(part)
			--local name_label = iup.label{title = name(part), size = nameSize,}
			local name_label = iup.stationbutton{
				title = name(part),
				size = nameSize,
				click = gkmisc.GetGameTime(),
				bgcolor = "0 0 0 0 *",
				fgcolor = "255 255 255",
				action = function(self)
					if (gkmisc.GetGameTime() - self.click) < 400 then
						ma.part_info(part, station_SET)
					else
						self.click = gkmisc.GetGameTime()
					end
				end,
			}
			
			local have_label, used_label, full_label
			if ma.manufacturables[part] then
				local font
				if (manu_have[part] + manu_used[part]) >= manu_full[part] then
					font = fontGreen
				else
					font = fontRed
				end
				have_label = iup.label{title = tostring(manu_have[part]), size = labelSize, fgcolor = font, alignment = a,}
				used_label = iup.label{title = tostring(manu_used[part]), size = labelSize, fgcolor = font, alignment = a,}
				full_label = iup.label{title = tostring(manu_full[part]), size = labelSize, fgcolor = font, alignment = a,}
			else
				local font
				if (rest_have[part] + rest_used[part]) >= rest_full[part] then
					font = fontGreen
				else
					font = fontRed
				end
				have_label = iup.label{title = tostring(rest_have[part]), size = labelSize, fgcolor = font, alignment = a,}
				used_label = iup.label{title = tostring(rest_used[part]), size = labelSize, fgcolor = font, alignment = a,}
				full_label = iup.label{title = tostring(rest_full[part]), size = labelSize, fgcolor = font, alignment = a,}
			end
			local hbox = iup.hbox{name_label, have_label, used_label, full_label, gap = "5",}
			table.insert(hboxes, hbox)
		end
		
		for k, v in pairs(manu_full) do
			create_hbox_line(k)
		end
		
		for k, v in pairs(rest_full) do
			create_hbox_line(k)
		end
		
		table.insert(hboxes, iup.fill{size = "1", expand = "YES", resize = "YES",})
		--print(spickle2(hboxes))
		
		local vbox = create_frame_vbox(hboxes)--iup.vbox(hboxes)
		--full = iup.hbox{create_scrollbox(vbox),}
		full = iup.hbox{iup.vbox{hbox_title, iup.hbox{create_scrollbox(vbox, 1000, 472), gap = "10",},},}--size = "1000x500", 
			
		return full
	end
	
	local function create_local(view)
		local localV
		local inventory = {}
		local station
		
		if view == "Local" then
			if ma.manufacturables[part_SET].stations[1] ~= "Dunno" then
				station = ma.manufacturables[part_SET].stations[1]
			elseif GetCurrentStationID() then
				station = ShortLocationStr(SplitStationID(GetCurrentStationID()))
			elseif GetAvailableMissions() then
				local smallestDist = math.huge
				local smallestDistStationId

				for _, data in ipairs(GetAvailableMissions()) do
					if data.dist < smallestDist then
						smallestDist = data.dist
						smallestDistStationId = data.stationid
					end
				end

				station = ShortLocationStr(SplitStationID(smallestDistStationId))
			else
				station = ShortLocationStr(GetHomeStation())
			end
		else
			station = "Global"
		end
		
		--print(station)
			
		if station ~= "Global" then
			for _, item in PlayerInventoryPairs() do
				local name = tostring(GetInventoryItemName(item))
				if ma.back[name] then
					local stationI = ShortLocationStr(SplitStationID(GetInventoryItemLocation(item)))
					if stationI == station then
						local id = id(name)
						local amount = tonumber(GetInventoryItemQuantity(item))
						if inventory[id] then
							inventory[id] = inventory[id] + amount
						else
							inventory[id] = amount
						end
					end
				end
			end
		else
			for _, item in PlayerInventoryPairs() do
				local name = tostring(GetInventoryItemName(item))
				if ma.back[name] then
					local id = id(name)
					local amount = tonumber(GetInventoryItemQuantity(item))
					if inventory[id] then
						inventory[id] = inventory[id] + amount
					else
						inventory[id] = amount
					end
				end
			end
		end
		
		local needed = {}
		for k, v in pairs(ma.manufacturables[part_SET].items) do
			needed[k] = v * quantity_SET
		end
		local have = {}
		for k, v in pairs(needed) do
			have[k] = 0
		end
		
		for k, v in pairs(inventory) do
			if needed[k] then
				have[k] = have[k] + v
			else
				--print(k)
			end
		end
		
		
		local nameSize = "666x25"
		local labelSize = "142"
		local titleColor = "0 0 0"
		local fontGreen = "0 255 0"
		local fontRed = "255 0 0"
		local a = "ACENTER"
		
		local hboxes = {gap = "5"}
		local hbox_title = iup.hbox{
			iup.label{title = "Name - ("..name(part_SET).." - "..station..")", size = nameSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Have", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Required", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			gap = "5",}
		
		local function create_hbox_line(part)
			--local name_label = iup.label{title = name(part), size = nameSize,}
			local name_label = iup.stationbutton{
				title = name(part),
				size = nameSize,
				click = gkmisc.GetGameTime(),
				bgcolor = "0 0 0 0 *",
				fgcolor = "255 255 255",
				action = function(self)
					if (gkmisc.GetGameTime() - self.click) < 400 then
						ma.part_info(part, station_SET)
					else
						self.click = gkmisc.GetGameTime()
					end
				end,
			}
			
			local have_label, full_label

			local font
			if have[part] >= needed[part] then
				font = fontGreen
			else
				font = fontRed
			end
			have_label = iup.label{title = tostring(have[part]), size = labelSize, fgcolor = font, alignment = a,}
			full_label = iup.label{title = tostring(needed[part]), size = labelSize, fgcolor = font, alignment = a,}

			local hbox = iup.hbox{name_label, have_label, full_label, gap = "5",}
			table.insert(hboxes, hbox)
		end
		
		for k, v in pairs(needed) do
			create_hbox_line(k)
		end
		
		table.insert(hboxes, iup.fill{size = "1", expand = "YES", resize = "YES",})
		
		local vbox = create_frame_vbox(hboxes)--iup.vbox(hboxes)

		localV = iup.hbox{iup.vbox{hbox_title, iup.hbox{create_scrollbox(vbox, 1000, 472), gap = "10",},},}
			
		return localV
	end			

	local function create_station()
		local stationIUP
		local manu_need = {}
		local rest_need = {}
		local manu_used = {}
		local rest_used = {}
		local manu_have = {}
		local rest_have = {}

		local inventory = {}
		
		local start_station = get_station(part_SET)
		--print(start_station)
		
		local function recursive_part_search(part, quantity, station2, orig)
			if ma.manufacturables[part] then
				if part ~= orig then
					if manu_need[station2][part] then
						manu_need[station2][part] = manu_need[station2][part] + quantity
					else
						manu_need[station2][part] = quantity
					end
				end
				local newS = get_station(part)
				if not manu_need[newS] then
					manu_need[newS] = {}
				end
				if not rest_need[newS] then
					rest_need[newS] = {}
				end
				for k, v in pairs(ma.manufacturables[part].items) do
					recursive_part_search(k, v * quantity, newS)
				end
			else
				if rest_need[station2][part] then
					rest_need[station2][part] = rest_need[station2][part] + quantity
				else
					rest_need[station2][part] = quantity
				end
			end
		end
		
		manu_need[start_station] = {}
		rest_need[start_station] = {}
		recursive_part_search(part_SET, quantity_SET, start_station, part_SET)
		
		for k, v in pairs(manu_need) do
			manu_have[k] = {}
			manu_used[k] = {}
			for a, b in pairs(v) do
				manu_have[k][a] = 0
				manu_used[k][a] = 0
			end
		end
		for k, v in pairs(rest_need) do
			rest_have[k] = {}
			rest_used[k] = {}
			for a, b in pairs(v) do
				rest_have[k][a] = 0
				rest_used[k][a] = 0
			end
		end
		
		for _, item in PlayerInventoryPairs() do
			local name = tostring(GetInventoryItemName(item))
			if ma.back[name] then
				local stationI = ShortLocationStr(SplitStationID(GetInventoryItemLocation(item)))
				if ma.manufacturables[id(name)] then
					if manu_need[stationI] then
						local id = id(name)
						if manu_need[stationI][id] then
							local amount = tonumber(GetInventoryItemQuantity(item))
							if inventory[stationI] then
								if inventory[stationI][id] then
									inventory[stationI][id] = inventory[stationI][id] + amount
								else
									inventory[stationI][id] = amount
								end
							else
								inventory[stationI] = {}
								inventory[stationI][id] = amount
							end
						end
					end
				else
					if rest_need[stationI] then
						local id = id(name)
						if rest_need[stationI][id] then
							local amount = tonumber(GetInventoryItemQuantity(item))
							if inventory[stationI] then
								if inventory[stationI][id] then
									inventory[stationI][id] = inventory[stationI][id] + amount
								else
									inventory[stationI][id] = amount
								end
							else
								inventory[stationI] = {}
								inventory[stationI][id] = amount
							end
						end
					end
				end
			end
		end
		
		--print(spickle2(inventory))
		--print(spickle2(manu_need))
		--print(spickle2(rest_need))
		--print(spickle2(manu_have))
		--print(spickle2(rest_have))
		for k, v in pairs(inventory) do
			for a, b in pairs(v) do
				if ma.manufacturables[a] then
					manu_have[k][a] = b
				else
					rest_have[k][a] = b
				end
			end
		end
		
		local function recursive_part_search2(part, quantity, station2, orig)
			if ma.manufacturables[part] then
				if part ~= orig then
					manu_used[station2][part] = manu_used[station2][part] + quantity
				end
				local S = get_station(part)
				for k, v in pairs(ma.manufacturables[part].items) do
					recursive_part_search(k, v * quantity, S)
				end
			else
				rest_used[station2][part] = rest_used[station2][part] + quantity
			end
		end
			
		for k, v in pairs(manu_have) do
			for a, b in pairs(v) do
				if b > 0 then
					if b <= (manu_need[k][a]) then
						recursive_part_search2(a, b, k, a)
					else
						recursive_part_search2(a, manu_need[k][a], k, a)
					end
				end
			end
		end
		
		local nameSize = "524x25"
		local labelSize = "142"
		local titleColor = "0 0 0"
		local miniTitleColor = "65 65 65"
		local fontGreen = "0 255 0"
		local fontRed = "255 0 0"
		local a = "ACENTER"
		
		local hboxes = {gap = "5"}
		local hbox_title = iup.hbox{
			iup.label{title = "Name", size = nameSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Have", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Used", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			iup.label{title = "Required", size = labelSize, bgcolor = titleColor, alignment = a,}, 
			gap = "5",}
		
		local function create_hbox_line(stationX, partX)
			--local name_label = iup.label{title = name(partX), size = nameSize,}
			local name_label = iup.stationbutton{
				title = name(partX),
				size = nameSize,
				click = gkmisc.GetGameTime(),
				bgcolor = "0 0 0 0 *",
				fgcolor = "255 255 255",
				action = function(self)
					if (gkmisc.GetGameTime() - self.click) < 400 then
						ma.part_info(partX, station_SET)
					else
						self.click = gkmisc.GetGameTime()
					end
				end,
			}
			
			local have_label, used_label, full_label
			if ma.manufacturables[partX] then
				local font
				if (manu_have[stationX][partX] + manu_used[stationX][partX]) >= manu_need[stationX][partX] then
					font = fontGreen
				else
					font = fontRed
				end
				have_label = iup.label{title = tostring(manu_have[stationX][partX]), size = labelSize, fgcolor = font, alignment = a,}
				used_label = iup.label{title = tostring(manu_used[stationX][partX]), size = labelSize, fgcolor = font, alignment = a,}
				full_label = iup.label{title = tostring(manu_need[stationX][partX]), size = labelSize, fgcolor = font, alignment = a,}
			else
				local font
				if (rest_have[stationX][partX] + rest_used[stationX][partX]) >= rest_need[stationX][partX] then
					font = fontGreen
				else
					font = fontRed
				end
				have_label = iup.label{title = tostring(rest_have[stationX][partX]), size = labelSize, fgcolor = font, alignment = a,}
				used_label = iup.label{title = tostring(rest_used[stationX][partX]), size = labelSize, fgcolor = font, alignment = a,}
				full_label = iup.label{title = tostring(rest_need[stationX][partX]), size = labelSize, fgcolor = font, alignment = a,}
			end
			local hbox = iup.hbox{name_label, have_label, used_label, full_label, gap = "5",}
			table.insert(hboxes, hbox)
		end
		
		local III = 0
		
		local function create_station_hbox_line(stationZ)
			if III > 0 then
				local gap_block = iup.hbox{
					iup.label{title = " ", size = nameSize,}, 
					iup.label{title = " ", size = labelSize,}, 
					iup.label{title = " ", size = labelSize,}, 
					iup.label{title = " ", size = labelSize,}, 
					gap = "5",}
				table.insert(hboxes, gap_block)
			end
			local st_title = iup.hbox{
				iup.label{title = stationZ, size = nameSize, bgcolor = miniTitleColor, alignment = a,}, 
				iup.label{title = " ", size = labelSize, bgcolor = miniTitleColor, alignment = a,}, 
				iup.label{title = " ", size = labelSize, bgcolor = miniTitleColor, alignment = a,}, 
				iup.label{title = " ", size = labelSize, bgcolor = miniTitleColor, alignment = a,}, 
				gap = "5",}
			table.insert(hboxes, st_title)
		end
		
		for k, v in pairs(manu_need) do
			create_station_hbox_line(k)
			III = 1
			for a, b in pairs(v) do
				create_hbox_line(k, a)
			end
			if rest_need[k] then
				for k, v in pairs(rest_need) do
					for a, b in pairs(v) do
						create_hbox_line(k, a)
					end
				end
				rest_need[k] = nil
			end
		end
		
		for k, v in pairs(rest_need) do
			create_station_hbox_line(k)
			for a, b in pairs(v) do
				create_hbox_line(k, a)
			end
		end
		
		table.insert(hboxes, iup.fill{size = "1", expand = "YES", resize = "YES",})
		--print(spickle2(hboxes))
		
		local vbox = create_frame_vbox(hboxes)--iup.vbox(hboxes)
		
		stationIUP = iup.hbox{iup.vbox{hbox_title, iup.hbox{create_scrollbox(vbox, 1000, 472), gap = "10",},},}
		
		return stationIUP
	end
	
	local function change_view_window()
		local parent = iup.GetParent(view_section)
		iup.Detach(view_section)
		iup.Destroy(view_section)
		if view_SET == "List (Full)" then
			view_section = create_full()
		elseif view_SET == "List (Local)" then
			view_section = create_local("Local")
		elseif view_SET == "List (Global)" then
			view_section = create_local("Global")
		elseif view_SET == "Tree" then
			view_section = create_tree()
		elseif view_SET == "Station" then
			view_section = create_station()
		else
			view_section = create_tree()
		end
		iup.Append(parent, view_section)
		iup.Map(dlg)
		iup.Refresh(dlg)
		station_SET = get_station(part_SET)
	end
	
	local set_btn = iup.stationbutton{
		title = "Go",
		size = "100",
		action = function()
			change_view_window()
		end,
	}
		
	local header = iup.hbox{dropdown_manu, quantity_text, dropdown_view, set_btn, gap = "5"}
	local closebtn = iup.stationbutton{title = "Close"}
	local farmbtn = iup.stationbutton{title = "Farm"}
	local version = iup.label{title = tostring(ma.version)}
	function farmbtn:action()
		ma.drop_farming()
	end
	
	if view_SET == "List (Full)" then
		view_section = create_full()
	elseif view_SET == "List (Local)" then
		view_section = create_local("Local")
	elseif view_SET == "List (Global)" then
		view_section = create_local("Global")
	elseif view_SET == "Tree" then
		view_section = create_tree()
	elseif view_SET == "Station" then
		view_section = create_station()
	else
		view_section = create_tree()
	end
	local main = iup.vbox{header, iup.hbox{view_section,}, resize = "NO", expand = "NO", iup.hbox{closebtn, farmbtn, version, gap = "5",}, gap = "5",}
	
	dlg = iup.dialog{
		iup.vbox{
			iup.fill{},
			iup.hbox{
				iup.fill{},
				main,
				iup.fill{},
			},
			iup.fill{},
		},
		--size = "1000x500",
		expand = "NO",
		topmost = "YES",
		fullscreen = "YES",
		defaultesc = closebtn,
		bgcolor = "0 0 0 64 *",
	}
	
	function closebtn:action()
		dlg:hide()
		dlg = nil
		collectgarbage()
	end

	dlg:show(iup.CENTER, iup.CENTER)
end

function ma.int(_, arg)
	local part, quantity

	if arg then
		part = tonumber(arg[1]) or 1781660161
		quantity = tonumber(arg[2]) or 1
	else
		part = 1781660161
		quantity = 1
	end
	ma.iup_create(part, quantity)
end

RegisterUserCommand('ma', ma.int)